import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  ChatConversation,
  ChatConversationParam,
  ChatMessage,
  ChatMessageParam
} from '@/api/love/chat/model';

/**
 * 查询聊天列表
 */
export async function pageChatConversation(params: ChatConversationParam) {
  const res = await request.get<ApiResult<PageResult<ChatConversation>>>(
    '/love/chat-conversation/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询聊天列表
 */
export async function pageChatMessage(params: ChatMessageParam) {
  const res = await request.get<ApiResult<PageResult<ChatMessage>>>(
    '/love/chat-message/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
/**
 * 查询日志列表
 */
export async function listChatConversation(params?: ChatConversationParam) {
  const res = await request.get<ApiResult<ChatConversation[]>>(
    '/love/chat-conversation',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加日志
 */
export async function addChatMessage(data: ChatMessage) {
  const res = await request.post<ApiResult<ChatConversation>>(
    '/love/chat-message',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加日志
 */
export async function addChatConversation(data: ChatConversation) {
  const res = await request.post<ApiResult<unknown>>(
    '/love/chat-conversation',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改日志
 */
export async function updateChatConversation(data: any) {
  const res = await request.put<ApiResult<unknown>>(
    '/love/chat-conversation',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 绑定日志
 */
export async function bindChatConversation(data: ChatConversation) {
  const res = await request.put<ApiResult<unknown>>(
    '/love/chat-conversation/bind',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量添加
 */
export async function addBatchChatConversation(data: ChatConversation[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/love/chat-conversation/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除日志
 */
export async function removeChatConversation(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/love/chat-conversation/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除日志
 */
export async function removeBatchChatConversation(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    '/love/chat-conversation/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
